Bug 997220 - Race in gluster_finish_aiocb
Race in gluster_finish_aiocb
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: qemu-kvm (Show other bugs)
6.5
Unspecified Unspecified
unspecified Severity unspecified
: rc
: ---
Assigned To: Asias He
Virtualization Bugs
:
Depends On:
Blocks: 1004733
  Show dependency treegraph
 
Reported: 2013-08-14 21:01 EDT by Asias He
Modified: 2013-12-02 18:26 EST (History)
11 users (show)

See Also:
Fixed In Version: qemu-kvm-0.12.1.2-2.400.el6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 1004733 (view as bug list)
Environment:
Last Closed: 2013-11-21 02:11:17 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Asias He 2013-08-14 21:01:18 EDT
Description of problem:

In block/gluster.c, we have
gluster_finish_aiocb
{
   if (retval != sizeof(acb)) {
      qemu_mutex_lock_iothread(); /* We are in gluster thread context */
      ...
      qemu_mutex_unlock_iothread();
   }
}

qemu tools, e.g. qemu-img, might race here because qemu_mutex_{lock,unlock}_iothread are a nop operation and gluster_finish_aiocb is in the gluster thread context.


Version-Release number of selected component (if applicable):


How reproducible:


Steps to Reproduce:
1.
2.
3.

Actual results:


Expected results:


Additional info:
This issue affects upstream and rhel7 qemu as well.
Comment 2 Asias He 2013-08-19 05:16:07 EDT
This is not easy to produce and verify. If I can figure out one. I will update it here.
Comment 10 errata-xmlrpc 2013-11-21 02:11:17 EST
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHSA-2013-1553.html

Note You need to log in before you can comment on or make changes to this bug.